functor SeqBFS(STSeq : ST_SEQUENCE) =
struct
  open STSeq
  type vertex = int
  type graph = (int seq) seq

  fun N(G : graph , F : int seq) = 
  let
    fun UV v = Seq.map (fn u => (u, SOME(v))) (Seq.nth G v)
  in
    Seq.flatten(Seq.map UV F)
  end

  fun BFS(G : graph , s : vertex) =
  let
    val n = Seq.length G

    fun BFS'(P : int option stseq, F : int seq) =
      if (Seq.length(F) = 0) 
      then toSeq(P)
      else let
        val Nbr = Seq.filter (fn (u,v) => (nth P u) = NONE) (N(G, F))
        val P' = inject Nbr P
        val F' = Seq.filter (fn (u,v) => (nth P' u) = v) Nbr
        val F'' = Seq.map (fn (u,v) => u) F'
      in BFS'(P', F'') end

    val P = Seq.tabulate (fn i => if (i=s) then SOME(s) else NONE) n

  in 
    BFS'(fromSeq(P), Seq.singleton(s))
  end

end
