(***************************************************************
 * DFS TEST
 ***************************************************************)

structure BFSTest =
struct

structure Table = Default.IntTable
structure Set = Table.Set
structure Seq = Default.Seq
structure BFS = TableBFS(Table)
structure BFSArray = SeqBFS(STArraySequence)

fun testBFS (E : (int*int) Seq.seq , s : int , V : int Seq.seq) =
    let
	val G = Table.map Set.fromSeq (Table.collect E)
	val V = Set.fromSeq V
    in
	if Set.equal(#1(BFS.BFS_reachable(G, s)), V) then ()
        else raise TH.FAILED "BFS"
    end

fun testBFSArray (E : (int*int) Seq.seq, n : int, s : int , V : int Seq.seq) =
    let
	val CE = Seq.collect Int.compare E
        val G = Seq.tabulate (fn i => Seq.empty()) n
	val G = Seq.inject CE G
        val P = BFSArray.BFS(G, s)
        val I = Seq.tabulate (fn i => i) n
        val V' = Seq.filter (fn i => (Seq.nth P i) <> NONE) I
	val V' = Set.fromSeq V'
	val V  = Set.fromSeq V
    in
	if Set.equal(V,V') then ()
        else raise TH.FAILED "BFSarray"
    end

fun test () =
    let
	val E = Seq.fromList [(0,1),(0,2),(1,3),(2,3),(3,4)]
	val V = Seq.fromList [0,1,2,3,4]
	val V' = Seq.fromList [1,3,4]
    in
	(testBFS(E, 0, V);
	 testBFS(E, 1, V');
	 testBFSArray(E, 5, 0, V);
	 testBFSArray(E, 5, 1, V'))
    end
end
