functor TableBFSTree(Table : TABLE) =
struct
  structure Set = Table.Set
  type vertex = Table.key
  type graph = Set.set Table.table
  type 'a table = 'a Table.table
  type set = Set.set
  type parentsTable = vertex table
  fun merge(A,B) = Table.merge (fn (a,b) => a) (A,B)

  fun outEdges (G : graph) (v : vertex) =
      case (Table.find G v) of
        NONE => Set.empty
      | SOME(ngh) => ngh

  (* Return neighbors tagged with where they come from *)
  fun N (G : graph) (F : set) =
      let
        fun tagNeighbors v = Table.tabulate (fn _ => v) (outEdges G v)
        val ngh = Table.tabulate tagNeighbors F
      in
        Table.reduce merge (Table.empty()) ngh
      end

  fun bfsTree (G :graph) (s : vertex) =
      let
        fun BFS(X : parentsTable, F : parentsTable) =
            if (Table.size F = 0) then X
            else let
               val X' = merge(X,F)
               val Ngh = N G (Table.domain F)
               val F' = Table.erase(Ngh, Table.domain X')
            in BFS(X', F') end
      in 
         BFS(Table.empty(), Table.singleton(s,s))
      end
end
