(***************************************************************
 * DFS TEST 
 ***************************************************************)

structure DFSTest =
struct

structure Table = Default.IntTable
structure Set = Table.Set
structure Seq = Default.Seq
structure cycleCheck = CycleCheck(Table)
structure topSort = TopSort(Table)

fun check ([], []) = true
    |   check (x::xs, y::ys) = (x = y) andalso check(xs,ys)
    |   check (_, _) = raise TH.FAILED "Topological Sort"

fun test () =
    let
	val E1 = Seq.fromList [(0,1),(0,2),(1,3),(2,3),(3,4)]
	val G1 = Table.map Set.fromSeq (Table.collect E1)
	val (_,S1) = topSort.dfs(G1, 0)
	val (_,(_,isCycle1)) = cycleCheck.dfs(G1, 0)

	val E2 = Seq.fromList [(0,1),(0,2),(1,3),(2,3),(3,4),(4,1)]
	val G2 = Table.map Set.fromSeq (Table.collect E2)
       	val (_,(_,isCycle2)) = cycleCheck.dfs(G2, 0)
    in
	check(S1, [0,2,1,3,4]) andalso (not isCycle1) andalso isCycle2
    end
end

