(***************************************************************
 * Dijkstra TEST 
 ***************************************************************)

structure DijkstraTest =
struct

structure Table = Default.IntTable
structure Set = Table.Set
structure Seq = Default.Seq
structure Dijkstra = TableDijkstra(Table)

fun toGraph edges =
let
    val eF = Seq.map (fn (u,v,w) => (u,(v,w))) edges
    val eB = Seq.map (fn (u,v,w) => (v,(u,w))) edges
in 
    Table.map Table.fromSeq (Table.collect(Seq.append(eF,eB)))
end

fun test () =
    let
	val E' = Seq.fromList [(0,1,1.0),(0,2,2.0),(1,3,1.1),(2,3,1.0)]
	val G' = toGraph E'
	val D = Dijkstra.Dijkstra(0, G')
	fun check(vtx, v) = 
	    case (Table.find D vtx) of
		NONE => raise TH.FAILED "dijkstra"
	      | SOME(x) => if Real.==(x, v) 
			   then () 
			   else raise TH.FAILED "dijkstra"
    in (check(3, 2.1); 
	check(2, 2.0))
    end

end
