functor LabelComponents(Seq : SEQUENCE) =
struct
   structure Rand = Random210
   type vertex = int

   fun isHead (rand : Rand.rand) (v : vertex) = 
      (Rand.hashInt rand v) > 0

   fun labelComponents(E, n) =
   let
     open Seq

     (* assumes:  V = {i | 0 <= i < |L|, i = L_i}, 
      *           E \subset V x V
      * returns forall 0 <= i < |L|, max {j | reachable(E,L_i,j)}
      *)
     fun LC(L : vertex seq, E : (vertex * vertex) seq, rand : Rand.rand) =
       if (length E = 0) then L
       else
	 let
           fun isHook(u,v) = (isHead rand u) andalso not(isHead rand v)
	   val Hooks = filter isHook E
	   val L'  = inject Hooks L
	   val E'  = map (fn (u,v) => ((nth L' u), (nth L' v))) E
	   val E'' = filter (fn (u,v) => u <> v) E'
	   val L'' = map (fn l => nth L' l) L'
           val rand' = Rand.next rand
	 in
	   LC(L'', E'', rand')
	 end
   in
     LC(tabulate (fn i => i) n, E, Rand.fromInt 0)
   end
end

