functor mcssDivConq(Seq : SEQUENCE) =
struct
  fun MCSS (A) =
  let
    fun MCSS' A =
      case Seq.showt A
      of Seq.ELT(v) => {mcss = v, prefix = v, suffix = v, total = v}
       | Seq.NODE(A1,A2) =>
         let
            val (B1, B2) = Primitives.par(fn () => MCSS'(A1),  
                                          fn () => MCSS'(A2))
            val {mcss = M1, prefix = P1, suffix = S1, total = T1} = B1
            val {mcss = M2, prefix = P2, suffix = S2, total = T2} = B2
         in
            {mcss =   Int.max(S1 + P2, Int.max(M1, M2)),
             prefix = Int.max(P1,      T1 + P2),
             suffix = Int.max(S2,      S1 + T2),
             total = T1 + T2}
         end
  in
    case Seq.showt A 
    of Seq.EMPTY => NONE
     |   _       => SOME(#mcss(MCSS' A))
  end
end
